
/******************************************************************************
* MODULE     : scheme.gen.h
* DESCRIPTION: fixed size schemes with reference counting
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <tree.gen.h>

#module scheme
#import tree

typedef tree scheme_tree;
typedef array<tree> array<scheme_tree>;

extern string TUPLE;

string scheme_tree_to_string (scheme_tree p);
scheme_tree string_to_scheme_tree (string s);
scheme_tree block_to_scheme_tree  (string s);
tree scheme_tree_to_tree (scheme_tree p);
scheme_tree tree_to_scheme_tree (tree t);

inline bool is_string (tree t) {
  return (N(t)==0); }
inline bool is_tuple (tree t) {
  return (t->label == TUPLE); }
inline bool is_tuple (tree t, char* s) {
  return
    (t->label == TUPLE) && (N(t)>=1) &&
    (N(t[0])==0) && (t[0]->label==s); }
inline bool is_tuple (tree t, string s) {
  return
    (t->label == TUPLE) && (N(t)>=1) &&
    (N(t[0])==0) && (t[0]->label==s); }
inline bool is_tuple (tree t, char* s, int n) {
  return
    (t->label == TUPLE) && (N(t)==(n+1)) &&
    (N(t[0])==0) && (t[0]->label==s); }
inline bool is_tuple (tree t, string s, int n) {
  return
    (t->label == TUPLE) && (N(t)==(n+1)) &&
    (N(t[0])==0) && (t[0]->label==s); }

#endmodule // scheme
