
/******************************************************************************
* MODULE     : convert.gen.h
* DESCRIPTION: various conversion routines
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <analyze.gen.h>
#include <data.gen.h>
#include <vars.gen.h>

#module convert
#import analyze
#import data
#import vars

string  edit_to_verbatim (tree t);
string  edit_to_tex (tree t, string mode);
string  edit_to_tex_document (tree t, string style, string lan);
string  edit_to_latex (tree t, string mode);
string  edit_to_latex_document (tree t, string style, string lan);
string  edit_to_html (tree t, string mode);
string  edit_to_html_document (tree t);

tree    verbatim_to_edit (string s);
tree    tex_to_edit (string s, string mode);
tree    tex_document_to_edit (string s, string& style);
tree    latex_to_edit (string s, string mode);
tree    latex_document_to_edit (string s, string& style);
tree    html_to_edit (string s, string mode);
tree    html_document_to_edit (string s, string& style);

string  var_tree_to_string (tree t);

tree    dl_compile_lisp (tree t);
tree    dl_eval_lisp (tree t);

#endmodule // convert
